/* $Id: main.c 16 2023-04-27 08:27:34Z nishi $ */

#include <swcli.h>
#include <swcli/login.h>
#include <swcli/swversion.h>
#include <swcli/create.h>
#include <swcli/logout.h>
#include <swcli/delete.h>

#include <stdio.h>
#include <string.h>

int argc;
char** argv;

void swcli_help(FILE* std){
	fprintf(std, "SWCLI v%s\n", SWCLI_VERSION);
	fprintf(std, "Usage: %s [options] [suboptions]\n", argv[0]);
	fprintf(std, "Options:\n");	
	fprintf(std, "\thelp         Show this help.\n");
	fprintf(std, "\tversion      Show the version of SWCLI.\n");
	fprintf(std, "\t---------------------------------------\n");
	fprintf(std, "\tlogin        Login to the SwineHub.\n");
	fprintf(std, "\tlogout       Logout from the SwineHub.\n");
	fprintf(std, "\tswversion    Get the SwineHub version.\n");
	fprintf(std, "\tcreate       Create the new repository.\n");
	fprintf(std, "\tdelete       Delete the new repository.\n");
}

int main(int _argc, char** _argv){
	argc = _argc;
	argv = _argv;
	if(argv[1] == NULL){
		fprintf(stderr, "Type `%s help` for the usage.\n", argv[0]);
		return 1;
	}else if(strcmp(argv[1], "help") == 0){
		swcli_help(stdout);
		return 0;
	}else if(strcmp(argv[1], "version") == 0){
		printf("SWCLI v%s Commit Date `%s`\n", SWCLI_VERSION, SWCLI_DATE);
	}else if(strcmp(argv[1], "login") == 0){
		swcli_login();
	}else if(strcmp(argv[1], "swversion") == 0){
		swcli_swversion();
	}else if(strcmp(argv[1], "create") == 0){
		swcli_create();
	}else if(strcmp(argv[1], "logout") == 0){
		swcli_logout();
	}else if(strcmp(argv[1], "delete") == 0){
		swcli_delete();
	}else{
		fprintf(stderr, "Unknown option: %s\n", argv[1]);
		fprintf(stderr, "Type `%s help` for the usage.\n", argv[0]);	
		return 1;
	}
}
